P1118 [USACO06FEB]数字三角形 (杨辉三角,dfs)

题目描述

FJ and his cows enjoy playing a mental game. They write down the numbers from 1 to N (1 <= N <= 10) in a certain order and then sum adjacent numbers to produce a new list with one fewer number. They repeat this until only a single number is left. For example, one instance of the game (when N=4) might go like this:

    3   1   2   4
      4   3   6
        7   9
         16

Behind FJ's back, the cows have started playing a more difficult game, in which they try to determine the starting sequence from only the final total and the number N. Unfortunately, the game is a bit above FJ's mental arithmetic capabilities.

Write a program to help FJ play the game and keep up with the cows.

有这么一个游戏:

写出一个1~N的排列a[i],然后每次将相邻两个数相加,构成新的序列,再对新序列进行这样的操作,显然每次构成的序列都比上一次的序列长度少1,直到只剩下一个数字位置。下面是一个例子:

3 1 2 4

4 3 6

7 9 16 最后得到16这样一个数字。

现在想要倒着玩这样一个游戏,如果知道N,知道最后得到的数字的大小sum,请你求出最初序列a[i],为1~N的一个排列。若答案有多种可能,则输出字典序最小的那一个。

[color=red]管理员注:本题描述有误,这里字典序指的是1,2,3,4,5,6,7,8,9,10,11,12

而不是1,10,11,12,2,3,4,5,6,7,8,9[/color]

输入输出格式

输入格式:

两个正整数n,sum。

输出格式:

输出包括1行,为字典序最小的那个答案。

当无解的时候,请什么也不输出。(好奇葩啊)

输入输出样例

输入样例#1: 复制
4 16
输出样例#1: 复制
3 1 2 4

说明

对于40%的数据,n≤7;

对于80%的数据,n≤10;

对于100%的数据,n≤12,sum≤12345。

这个题目需要一些观察,手动模拟一下我们会发现,对于n=3,sum=a+3b+c,n=4,sum=a+3b+3c+d....其实就是一个杨辉三角,这个很重要,再就是对题意的理解,1-n的排列的意思是,有n个数字,数字一定是1-n的一种排列(我搞成了只有n个数,dfs卡了半天不知道怎么存数据,盲人.jpg)。这样题目就容易多了,只要搜索一下符合条件的数就行了,然后把明显不需要的sum去掉,因为dfs从1开始,首个解一定是字典序最小的,不需要复杂的剪枝。

#include <bits/stdc++.h>

using namespace std;

int yh[20][20],n,sum,a[20],vis[20],f;

void create()                   //打表杨辉三角
{
    yh[1][1]=1;
    for(int i=2; i<=n; i++)
        for(int j=1; j<=i; j++)
            yh[i][j]=yh[i-1][j]+yh[i-1][j-1];
}

void dfs(int p,int s)  //p储存扩展层数,s储存和
{
    if(f) return;
    if(s>sum) return;
    if(s==sum && p>n)
    {
        for(int i=1;i<=n;i++)
            cout<<a[i]<<" ";
        f=1;
        return;
    }

    for(int i=1;i<=n;i++)
    {
        if(vis[i]) continue;
        a[p]=i;
        s+=a[p]*yh[n][p];
        vis[i]=1;
        dfs(p+1,s);
        vis[i]=0;
        s-=a[p]*yh[n][p];
    }

}

int main()
{
    cin>>n>>sum;
    create();
    dfs(1,0);
    return 0;
}
View Code
原文地址:https://www.cnblogs.com/youchandaisuki/p/8709309.html